import cython
import numpy as np
cimport numpy as npc

# Syntax rules are very poorly documented. 
cdef extern from "integrate_py.cpp":
    void mexFunction( double tout[], double prhs[], int nY0, double y0[], double tspanValue, double stepSizeValue)
    
cpdef yeast_model(npc.ndarray[npc.float64_t, ndim=1, mode="c"] paramarray, npc.ndarray[npc.float64_t, ndim=1, mode="c"] icarray, npc.ndarray[npc.float64_t, ndim=1, mode="c"] outarray):
    # out_array = npc.zeros(27*40001,dtype='float64_t') Fails in here because it might not be C formatted, and no one wrote documentation on how, in this context, to make sure it is. 
    mexFunction( &outarray[0], &paramarray[0], 26, &icarray[0], 1000, 0.05)
    return outarray
    
def call(npc.ndarray[npc.float64_t, ndim=1, mode="c"] paramarray, npc.ndarray[npc.float64_t, ndim=1, mode="c"] icarray):
    out_array = np.zeros(36*20001,dtype='float64')
    yeast_model(paramarray, icarray, out_array)
    # Convert to a genuine 2D array
    out_array_2d = np.reshape(out_array,(20001,36))
    
    return out_array_2d
    
# Note: Run time is almost completely proportional to number of time points requested. With 40000, is 13.3s / 1000; with 4000, 1.6s / 1000. 


cpdef yeast_model2000(npc.ndarray[npc.float64_t, ndim=1, mode="c"] paramarray, npc.ndarray[npc.float64_t, ndim=1, mode="c"] icarray, npc.ndarray[npc.float64_t, ndim=1, mode="c"] outarray):
    # out_array = npc.zeros(27*40001,dtype='float64_t') Fails in here because it might not be C formatted, and no one wrote documentation on how, in this context, to make sure it is. 
    mexFunction( &outarray[0], &paramarray[0], 26, &icarray[0], 2000, 0.05)
    return outarray
    
def call2000(npc.ndarray[npc.float64_t, ndim=1, mode="c"] paramarray, npc.ndarray[npc.float64_t, ndim=1, mode="c"] icarray):
    out_array = np.zeros(36*40001,dtype='float64')
    yeast_model2000(paramarray, icarray, out_array)
    # Convert to a genuine 2D array
    out_array_2d = np.reshape(out_array,(40001,36))
    
    return out_array_2d
